﻿using System;
using System.Linq;
using System.Reflection;
using NHibernate;
using NHibernate.Event;
using NHibernate.Persister.Entity;

namespace Test
{
    public class NHibernateAuditListener : IPostInsertEventListener
    {
        public void OnPostInsert(PostInsertEvent @event)
        {
            if (@event.Entity is IAuditable)
            {
                string user = Environment.UserName;
                DateTime date = DateTime.Now;
                AbstractEntityPersister abstractPersister = @event.Persister.ClassMetadata as AbstractEntityPersister;
                string table = abstractPersister.TableName;

                for (int index = 0; index < @event.State.Length; index++)
                {
                    ChangeLog logItem = new ChangeLog()
                    {
                        User = user,
                        Date = date,
                        Field = @event.Persister.PropertyNames[index],
                        Mode = "INSERT",
                        Table = table,
                        OldValue = string.Empty,
                        NewValue = @event.State[index].ToString()
                    };
                    @event.Session.Save(logItem);
                }
            }
        }
    }
}